// Package v2 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package v2

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
)

const (
	BearerScopes = "Bearer.Scopes"
)

// Defines values for AzureUploadOptionsHyperVGeneration.
const (
	AzureUploadOptionsHyperVGenerationV1 AzureUploadOptionsHyperVGeneration = "V1"

	AzureUploadOptionsHyperVGenerationV2 AzureUploadOptionsHyperVGeneration = "V2"
)

// Defines values for BlueprintCustomizationsPartitioningMode.
const (
	BlueprintCustomizationsPartitioningModeAutoLvm BlueprintCustomizationsPartitioningMode = "auto-lvm"

	BlueprintCustomizationsPartitioningModeLvm BlueprintCustomizationsPartitioningMode = "lvm"

	BlueprintCustomizationsPartitioningModeRaw BlueprintCustomizationsPartitioningMode = "raw"
)

// Defines values for ComposeStatusValue.
const (
	ComposeStatusValueFailure ComposeStatusValue = "failure"

	ComposeStatusValuePending ComposeStatusValue = "pending"

	ComposeStatusValueSuccess ComposeStatusValue = "success"
)

// Defines values for CustomizationsPartitioningMode.
const (
	CustomizationsPartitioningModeAutoLvm CustomizationsPartitioningMode = "auto-lvm"

	CustomizationsPartitioningModeLvm CustomizationsPartitioningMode = "lvm"

	CustomizationsPartitioningModeRaw CustomizationsPartitioningMode = "raw"
)

// Defines values for ImageSBOMPipelinePurpose.
const (
	ImageSBOMPipelinePurposeBuildroot ImageSBOMPipelinePurpose = "buildroot"

	ImageSBOMPipelinePurposeImage ImageSBOMPipelinePurpose = "image"
)

// Defines values for ImageSBOMSbomType.
const (
	ImageSBOMSbomTypeSpdx ImageSBOMSbomType = "spdx"
)

// Defines values for ImageStatusValue.
const (
	ImageStatusValueBuilding ImageStatusValue = "building"

	ImageStatusValueFailure ImageStatusValue = "failure"

	ImageStatusValuePending ImageStatusValue = "pending"

	ImageStatusValueRegistering ImageStatusValue = "registering"

	ImageStatusValueSuccess ImageStatusValue = "success"

	ImageStatusValueUploading ImageStatusValue = "uploading"
)

// Defines values for ImageTypes.
const (
	ImageTypesAws ImageTypes = "aws"

	ImageTypesAwsHaRhui ImageTypes = "aws-ha-rhui"

	ImageTypesAwsRhui ImageTypes = "aws-rhui"

	ImageTypesAwsSapRhui ImageTypes = "aws-sap-rhui"

	ImageTypesAzure ImageTypes = "azure"

	ImageTypesAzureEap7Rhui ImageTypes = "azure-eap7-rhui"

	ImageTypesAzureRhui ImageTypes = "azure-rhui"

	ImageTypesAzureSapRhui ImageTypes = "azure-sap-rhui"

	ImageTypesEdgeCommit ImageTypes = "edge-commit"

	ImageTypesEdgeContainer ImageTypes = "edge-container"

	ImageTypesEdgeInstaller ImageTypes = "edge-installer"

	ImageTypesGcp ImageTypes = "gcp"

	ImageTypesGcpRhui ImageTypes = "gcp-rhui"

	ImageTypesGuestImage ImageTypes = "guest-image"

	ImageTypesImageInstaller ImageTypes = "image-installer"

	ImageTypesIotBootableContainer ImageTypes = "iot-bootable-container"

	ImageTypesIotCommit ImageTypes = "iot-commit"

	ImageTypesIotContainer ImageTypes = "iot-container"

	ImageTypesIotInstaller ImageTypes = "iot-installer"

	ImageTypesIotRawImage ImageTypes = "iot-raw-image"

	ImageTypesIotSimplifiedInstaller ImageTypes = "iot-simplified-installer"

	ImageTypesLiveInstaller ImageTypes = "live-installer"

	ImageTypesMinimalRaw ImageTypes = "minimal-raw"

	ImageTypesOci ImageTypes = "oci"

	ImageTypesVsphere ImageTypes = "vsphere"

	ImageTypesVsphereOva ImageTypes = "vsphere-ova"

	ImageTypesWsl ImageTypes = "wsl"
)

// Defines values for UploadStatusValue.
const (
	UploadStatusValueFailure UploadStatusValue = "failure"

	UploadStatusValuePending UploadStatusValue = "pending"

	UploadStatusValueRunning UploadStatusValue = "running"

	UploadStatusValueSuccess UploadStatusValue = "success"
)

// Defines values for UploadTypes.
const (
	UploadTypesAws UploadTypes = "aws"

	UploadTypesAwsS3 UploadTypes = "aws.s3"

	UploadTypesAzure UploadTypes = "azure"

	UploadTypesContainer UploadTypes = "container"

	UploadTypesGcp UploadTypes = "gcp"

	UploadTypesLocal UploadTypes = "local"

	UploadTypesOciObjectstorage UploadTypes = "oci.objectstorage"

	UploadTypesPulpOstree UploadTypes = "pulp.ostree"
)

// AWSEC2CloneCompose defines model for AWSEC2CloneCompose.
type AWSEC2CloneCompose struct {
	Region            string    `json:"region"`
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// AWSEC2UploadOptions defines model for AWSEC2UploadOptions.
type AWSEC2UploadOptions struct {
	Region            string   `json:"region"`
	ShareWithAccounts []string `json:"share_with_accounts"`
	SnapshotName      *string  `json:"snapshot_name,omitempty"`
}

// AWSEC2UploadStatus defines model for AWSEC2UploadStatus.
type AWSEC2UploadStatus struct {
	Ami    string `json:"ami"`
	Region string `json:"region"`
}

// AWSS3UploadOptions defines model for AWSS3UploadOptions.
type AWSS3UploadOptions struct {
	// If set to false (the default value), a long, obfuscated URL
	// is returned. Its expiration might be sooner than for other upload
	// targets.
	//
	// If set to true, a shorter URL is returned and
	// its expiration is the same as for the other upload targets.
	Public *bool  `json:"public,omitempty"`
	Region string `json:"region"`
}

// AWSS3UploadStatus defines model for AWSS3UploadStatus.
type AWSS3UploadStatus struct {
	Url string `json:"url"`
}

// AzureUploadOptions defines model for AzureUploadOptions.
type AzureUploadOptions struct {
	// Choose the VM Image HyperV generation, different features on Azure are available
	// depending on the HyperV generation.
	HyperVGeneration *AzureUploadOptionsHyperVGeneration `json:"hyper_v_generation,omitempty"`

	// Name of the uploaded image. It must be unique in the given resource group.
	// If name is omitted from the request, a random one based on a UUID is
	// generated.
	ImageName *string `json:"image_name,omitempty"`

	// Location of the provided resource_group, where the image should be uploaded and registered.
	// How to list all locations:
	// https://docs.microsoft.com/en-us/cli/azure/account?view=azure-cli-latest#az_account_list_locations'
	// If the location is not specified, it is deducted from the provided resource_group.
	Location *string `json:"location,omitempty"`

	// Name of the resource group where the image should be uploaded.
	ResourceGroup string `json:"resource_group"`

	// ID of subscription where the image should be uploaded.
	SubscriptionId string `json:"subscription_id"`

	// ID of the tenant where the image should be uploaded.
	// How to find it in the Azure Portal:
	// https://docs.microsoft.com/en-us/azure/active-directory/fundamentals/active-directory-how-to-find-tenant
	TenantId string `json:"tenant_id"`
}

// Choose the VM Image HyperV generation, different features on Azure are available
// depending on the HyperV generation.
type AzureUploadOptionsHyperVGeneration string

// AzureUploadStatus defines model for AzureUploadStatus.
type AzureUploadStatus struct {
	ImageName string `json:"image_name"`
}

// Blueprint defines model for Blueprint.
type Blueprint struct {
	// Architecture to use for the compose. If left empty the host arch
	// will be used.
	Architecture *string `json:"architecture,omitempty"`

	// Container images to embed into the final artfact
	Containers     *[]Container             `json:"containers,omitempty"`
	Customizations *BlueprintCustomizations `json:"customizations,omitempty"`
	Description    *string                  `json:"description,omitempty"`

	// The distribution to use for the compose. If left empty the host
	// distro will be used.
	Distro *string `json:"distro,omitempty"`

	// Package groups to be installed
	Groups *[]PackageGroup `json:"groups,omitempty"`

	// An alias for packages, retained for backwards compatability
	Modules *[]Package `json:"modules,omitempty"`
	Name    string     `json:"name"`

	// Packages to be installed
	Packages *[]Package `json:"packages,omitempty"`

	// A semver version number
	Version *string `json:"version,omitempty"`
}

// BlueprintCustomizations defines model for BlueprintCustomizations.
type BlueprintCustomizations struct {
	Cacerts *CACertsCustomization `json:"cacerts,omitempty"`

	// Directories to create in the final artifact
	Directories *[]Directory `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo *FDO `json:"fdo,omitempty"`

	// Files to create in the final artifact
	Files *[]BlueprintFile `json:"files,omitempty"`

	// List of filesystem mountpoints to create
	Filesystem *[]BlueprintFilesystem `json:"filesystem,omitempty"`

	// Enable FIPS mode
	Fips *bool `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *BlueprintFirewall `json:"firewall,omitempty"`

	// List of groups to create
	Group *[]Group `json:"group,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale            `json:"locale,omitempty"`
	Openscap *BlueprintOpenSCAP `json:"openscap,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *BlueprintCustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Repositories to write to /etc/yum.repos.d/ in the final image. Note
	// that these are not used at build time.
	Repositories *[]BlueprintRepository `json:"repositories,omitempty"`
	Rhsm         *RHSMCustomization     `json:"rhsm,omitempty"`
	Rpm          *RPMCustomization      `json:"rpm,omitempty"`
	Services     *Services              `json:"services,omitempty"`

	// List of ssh keys
	Sshkey *[]SSHKey `json:"sshkey,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`

	// List of users to create
	User *[]BlueprintUser `json:"user,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type BlueprintCustomizationsPartitioningMode string

// A custom file to create in the final artifact.
type BlueprintFile struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// BlueprintFilesystem defines model for BlueprintFilesystem.
type BlueprintFilesystem struct {
	// size of the filesystem in bytes
	Minsize    uint64 `json:"minsize"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type BlueprintFirewall struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
	Zones    *[]FirewallZones  `json:"zones,omitempty"`
}

// BlueprintOpenSCAP defines model for BlueprintOpenSCAP.
type BlueprintOpenSCAP struct {
	Datastream    *string                `json:"datastream,omitempty"`
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// BlueprintRepository defines model for BlueprintRepository.
type BlueprintRepository struct {
	Baseurls   *[]string `json:"baseurls,omitempty"`
	Enabled    *bool     `json:"enabled,omitempty"`
	Filename   *string   `json:"filename,omitempty"`
	Gpgcheck   *bool     `json:"gpgcheck,omitempty"`
	Gpgkeys    *[]string `json:"gpgkeys,omitempty"`
	Id         string    `json:"id"`
	Metalink   *string   `json:"metalink,omitempty"`
	Mirrorlist *string   `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool   `json:"module_hotfixes,omitempty"`
	Name           *string `json:"name,omitempty"`
	Priority       *int    `json:"priority,omitempty"`
	RepoGpgcheck   *bool   `json:"repo_gpgcheck,omitempty"`
	Sslverify      *bool   `json:"sslverify,omitempty"`
}

// BlueprintUser defines model for BlueprintUser.
type BlueprintUser struct {
	Description *string `json:"description,omitempty"`

	// Group id to use instead of the default
	Gid *int `json:"gid,omitempty"`

	// A list of additional groups to add the user to
	Groups *[]string `json:"groups,omitempty"`

	// The user's home directory
	Home *string `json:"home,omitempty"`

	// ssh public key
	Key  *string `json:"key,omitempty"`
	Name string  `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`

	// Login shell to use
	Shell *string `json:"shell,omitempty"`

	// User id to use instead of the default
	Uid *int `json:"uid,omitempty"`
}

// CACertsCustomization defines model for CACertsCustomization.
type CACertsCustomization struct {
	PemCerts []string `json:"pem_certs"`
}

// CloneComposeBody defines model for CloneComposeBody.
type CloneComposeBody interface{}

// CloneComposeResponse defines model for CloneComposeResponse.
type CloneComposeResponse struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// CloneStatus defines model for CloneStatus.
type CloneStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded struct due to allOf(#/components/schemas/UploadStatus)
	UploadStatus `yaml:",inline"`
}

// ComposeId defines model for ComposeId.
type ComposeId struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Id string `json:"id"`
}

// ComposeLogs defines model for ComposeLogs.
type ComposeLogs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageBuilds []interface{} `json:"image_builds"`
	Koji        *KojiLogs     `json:"koji,omitempty"`
}

// ComposeManifests defines model for ComposeManifests.
type ComposeManifests struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Manifests []interface{} `json:"manifests"`
}

// ComposeMetadata defines model for ComposeMetadata.
type ComposeMetadata struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// ID (hash) of the built commit
	OstreeCommit *string `json:"ostree_commit,omitempty"`

	// Package list including NEVRA
	Packages *[]PackageMetadata `json:"packages,omitempty"`
}

// ComposeRequest defines model for ComposeRequest.
type ComposeRequest struct {
	Blueprint      *Blueprint      `json:"blueprint,omitempty"`
	Customizations *Customizations `json:"customizations,omitempty"`
	Distribution   string          `json:"distribution"`
	ImageRequest   *ImageRequest   `json:"image_request,omitempty"`
	ImageRequests  *[]ImageRequest `json:"image_requests,omitempty"`
	Koji           *Koji           `json:"koji,omitempty"`
}

// ComposeSBOMs defines model for ComposeSBOMs.
type ComposeSBOMs struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	// The SBOM documents for each image built in the compose.
	Items [][]ImageSBOM `json:"items"`
}

// ComposeStatus defines model for ComposeStatus.
type ComposeStatus struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	ImageStatus   ImageStatus        `json:"image_status"`
	ImageStatuses *[]ImageStatus     `json:"image_statuses,omitempty"`
	KojiStatus    *KojiStatus        `json:"koji_status,omitempty"`
	Status        ComposeStatusValue `json:"status"`
}

// ComposeStatusError defines model for ComposeStatusError.
type ComposeStatusError struct {
	Details *interface{} `json:"details,omitempty"`
	Id      int          `json:"id"`
	Reason  string       `json:"reason"`
}

// ComposeStatusValue defines model for ComposeStatusValue.
type ComposeStatusValue string

// Container defines model for Container.
type Container struct {
	// Name to use for the container from the image
	Name *string `json:"name,omitempty"`

	// Reference to the container to embed
	Source string `json:"source"`

	// Control TLS verifification
	TlsVerify *bool `json:"tls_verify,omitempty"`
}

// ContainerUploadOptions defines model for ContainerUploadOptions.
type ContainerUploadOptions struct {
	// Name for the created container image
	Name *string `json:"name,omitempty"`

	// Tag for the created container image
	Tag *string `json:"tag,omitempty"`
}

// ContainerUploadStatus defines model for ContainerUploadStatus.
type ContainerUploadStatus struct {
	// Digest of the manifest of the uploaded container on the registry
	Digest string `json:"digest"`

	// FQDN of the uploaded image
	Url string `json:"url"`
}

// CustomRepository defines model for CustomRepository.
type CustomRepository struct {
	Baseurl        *[]string `json:"baseurl,omitempty"`
	CheckGpg       *bool     `json:"check_gpg,omitempty"`
	CheckRepoGpg   *bool     `json:"check_repo_gpg,omitempty"`
	Enabled        *bool     `json:"enabled,omitempty"`
	Filename       *string   `json:"filename,omitempty"`
	Gpgkey         *[]string `json:"gpgkey,omitempty"`
	Id             string    `json:"id"`
	Metalink       *string   `json:"metalink,omitempty"`
	Mirrorlist     *string   `json:"mirrorlist,omitempty"`
	ModuleHotfixes *bool     `json:"module_hotfixes,omitempty"`
	Name           *string   `json:"name,omitempty"`
	Priority       *int      `json:"priority,omitempty"`
	SslVerify      *bool     `json:"ssl_verify,omitempty"`
}

// Customizations defines model for Customizations.
type Customizations struct {
	Cacerts    *CACertsCustomization `json:"cacerts,omitempty"`
	Containers *[]Container          `json:"containers,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will be used to depsolve and retrieve packages. Additionally,
	// these packages will be saved and imported to the `/etc/yum.repos.d/` directory
	// on the image
	CustomRepositories *[]CustomRepository `json:"custom_repositories,omitempty"`
	Directories        *[]Directory        `json:"directories,omitempty"`

	// FIDO device onboard configuration
	Fdo        *FDO          `json:"fdo,omitempty"`
	Files      *[]File       `json:"files,omitempty"`
	Filesystem *[]Filesystem `json:"filesystem,omitempty"`

	// System FIPS mode setup
	Fips *FIPS `json:"fips,omitempty"`

	// Firewalld configuration
	Firewall *FirewallCustomization `json:"firewall,omitempty"`

	// List of groups to create
	Groups *[]Group `json:"groups,omitempty"`

	// Configures the hostname
	Hostname *string `json:"hostname,omitempty"`

	// Ignition configuration
	Ignition *Ignition `json:"ignition,omitempty"`

	// Name of the installation device, currently only useful for the edge-simplified-installer type
	InstallationDevice *string    `json:"installation_device,omitempty"`
	Installer          *Installer `json:"installer,omitempty"`
	Kernel             *Kernel    `json:"kernel,omitempty"`

	// Locale configuration
	Locale   *Locale   `json:"locale,omitempty"`
	Openscap *OpenSCAP `json:"openscap,omitempty"`
	Packages *[]string `json:"packages,omitempty"`

	// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
	// there are one or more mountpoints in which case it will use LVM. 'lvm' always
	// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
	// even when there are one or more mountpoints.
	PartitioningMode *CustomizationsPartitioningMode `json:"partitioning_mode,omitempty"`

	// Extra repositories for packages specified in customizations. These
	// repositories will only be used to depsolve and retrieve packages
	// for the OS itself (they will not be available for the build root or
	// any other part of the build process). The package_sets field for these
	// repositories is ignored.
	PayloadRepositories *[]Repository      `json:"payload_repositories,omitempty"`
	Rhsm                *RHSMCustomization `json:"rhsm,omitempty"`
	Rpm                 *RPMCustomization  `json:"rpm,omitempty"`
	Services            *Services          `json:"services,omitempty"`
	Subscription        *Subscription      `json:"subscription,omitempty"`

	// Timezone configuration
	Timezone *Timezone `json:"timezone,omitempty"`
	Users    *[]User   `json:"users,omitempty"`
}

// Select how the disk image will be partitioned. 'auto-lvm' will use raw unless
// there are one or more mountpoints in which case it will use LVM. 'lvm' always
// uses LVM, even when there are no extra mountpoints. 'raw' uses raw partitions
// even when there are one or more mountpoints.
type CustomizationsPartitioningMode string

// DNFPluginConfig defines model for DNFPluginConfig.
type DNFPluginConfig struct {
	Enabled *bool `json:"enabled,omitempty"`
}

// DepsolveRequest defines model for DepsolveRequest.
type DepsolveRequest struct {
	Architecture string        `json:"architecture"`
	Blueprint    Blueprint     `json:"blueprint"`
	Distribution string        `json:"distribution"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// DepsolveResponse defines model for DepsolveResponse.
type DepsolveResponse struct {
	// Package list including NEVRA
	Packages []PackageMetadata `json:"packages"`
}

// A custom directory to create in the final artifact.
type Directory struct {
	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the directory as a group name or a gid
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the directory in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the directory
	Path string `json:"path"`

	// Owner of the directory as a user name or a uid
	User *interface{} `json:"user,omitempty"`
}

// Error defines model for Error.
type Error struct {
	// Embedded struct due to allOf(#/components/schemas/ObjectReference)
	ObjectReference `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Code        string       `json:"code"`
	Details     *interface{} `json:"details,omitempty"`
	OperationId string       `json:"operation_id"`
	Reason      string       `json:"reason"`
}

// ErrorList defines model for ErrorList.
type ErrorList struct {
	// Embedded struct due to allOf(#/components/schemas/List)
	List `yaml:",inline"`
	// Embedded fields due to inline allOf schema
	Items []Error `json:"items"`
}

// FIDO device onboard configuration
type FDO struct {
	DiMfgStringTypeMacIface *string `json:"di_mfg_string_type_mac_iface,omitempty"`
	DiunPubKeyHash          *string `json:"diun_pub_key_hash,omitempty"`
	DiunPubKeyInsecure      *string `json:"diun_pub_key_insecure,omitempty"`
	DiunPubKeyRootCerts     *string `json:"diun_pub_key_root_certs,omitempty"`
	ManufacturingServerUrl  *string `json:"manufacturing_server_url,omitempty"`
}

// System FIPS mode setup
type FIPS struct {
	// Enables the system FIPS mode
	Enabled *bool `json:"enabled,omitempty"`
}

// A custom file to create in the final artifact.
type File struct {
	// Contents of the file as plain text
	Data *string `json:"data,omitempty"`

	// Ensure that the parent directories exist
	EnsureParents *bool `json:"ensure_parents,omitempty"`

	// Group of the file as a gid or a group name
	Group *interface{} `json:"group,omitempty"`

	// Permissions string for the file in octal format
	Mode *string `json:"mode,omitempty"`

	// Path to the file
	Path string `json:"path"`

	// Owner of the file as a uid or a user name
	User *interface{} `json:"user,omitempty"`
}

// Filesystem defines model for Filesystem.
type Filesystem struct {
	// size of the filesystem in bytes
	MinSize    uint64 `json:"min_size"`
	Mountpoint string `json:"mountpoint"`
}

// Firewalld configuration
type FirewallCustomization struct {
	// List of ports (or port ranges) and protocols to open
	Ports *[]string `json:"ports,omitempty"`

	// Firewalld services to enable or disable
	Services *FirewallServices `json:"services,omitempty"`
}

// Firewalld services to enable or disable
type FirewallServices struct {
	// List of services to disable
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable
	Enabled *[]string `json:"enabled,omitempty"`
}

// Bind a list of network sources to a zone to restrict traffic from
// those sources based on the settings of the zone.
type FirewallZones struct {
	// name of the zone, if left empty the sources will apply to
	// the default zone.
	Name *string `json:"name,omitempty"`

	// List of sources for the zone
	Sources *[]string `json:"sources,omitempty"`
}

// GCPUploadOptions defines model for GCPUploadOptions.
type GCPUploadOptions struct {
	// Name of an existing STANDARD Storage class Bucket.
	Bucket *string `json:"bucket,omitempty"`

	// The name to use for the imported and shared Compute Engine image.
	// The image name must be unique within the GCP project, which is used
	// for the OS image upload and import. If not specified a random
	// 'composer-api-<uuid>' string is used as the image name.
	ImageName *string `json:"image_name,omitempty"`

	// The GCP region where the OS image will be imported to and shared from.
	// The value must be a valid GCP location. See https://cloud.google.com/storage/docs/locations.
	// If not specified, the multi-region location closest to the source
	// (source Storage Bucket location) is chosen automatically.
	Region string `json:"region"`

	// List of valid Google accounts to share the imported Compute Engine image with.
	// Each string must contain a specifier of the account type. Valid formats are:
	//   - 'user:{emailid}': An email address that represents a specific
	//     Google account. For example, 'alice@example.com'.
	//   - 'serviceAccount:{emailid}': An email address that represents a
	//     service account. For example, 'my-other-app@appspot.gserviceaccount.com'.
	//   - 'group:{emailid}': An email address that represents a Google group.
	//     For example, 'admins@example.com'.
	//   - 'domain:{domain}': The G Suite domain (primary) that represents all
	//     the users of that domain. For example, 'google.com' or 'example.com'.
	// If not specified, the imported Compute Engine image is not shared with any
	// account.
	ShareWithAccounts *[]string `json:"share_with_accounts,omitempty"`
}

// GCPUploadStatus defines model for GCPUploadStatus.
type GCPUploadStatus struct {
	ImageName string `json:"image_name"`
	ProjectId string `json:"project_id"`
}

// Group defines model for Group.
type Group struct {
	// Group id of the group to create (optional)
	Gid *int `json:"gid,omitempty"`

	// Name of the group to create
	Name string `json:"name"`
}

// Ignition configuration
type Ignition struct {
	Embedded  *IgnitionEmbedded  `json:"embedded,omitempty"`
	Firstboot *IgnitionFirstboot `json:"firstboot,omitempty"`
}

// IgnitionEmbedded defines model for IgnitionEmbedded.
type IgnitionEmbedded struct {
	Config string `json:"config"`
}

// IgnitionFirstboot defines model for IgnitionFirstboot.
type IgnitionFirstboot struct {
	// Provisioning URL
	Url string `json:"url"`
}

// ImageRequest defines model for ImageRequest.
type ImageRequest struct {
	Architecture string       `json:"architecture"`
	ImageType    ImageTypes   `json:"image_type"`
	Ostree       *OSTree      `json:"ostree,omitempty"`
	Repositories []Repository `json:"repositories"`

	// Size of image, in bytes. When set to 0 the image size is a minimum
	// defined by the image type.
	Size *uint64 `json:"size,omitempty"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions *UploadOptions `json:"upload_options,omitempty"`

	// The type and options for multiple upload targets. Each item defines
	// a separate upload destination with its own options. Multiple
	// different targets as well as multiple targets of the same kind are
	// supported.
	UploadTargets *[]UploadTarget `json:"upload_targets,omitempty"`
}

// ImageSBOM defines model for ImageSBOM.
type ImageSBOM struct {
	// The name of the osbuild pipeline which has the packages described
	// in the SBOM installed.
	PipelineName string `json:"pipeline_name"`

	// The purpose of the pipeline. The `buildroot` pipeline was used for
	// the build environment dueing the image build. The `image` pipeline
	// represents the actual content of the image. Due to the nature of
	// some image types, there may be multiple pipelines of the same
	// purpose.
	PipelinePurpose ImageSBOMPipelinePurpose `json:"pipeline_purpose"`

	// The SBOM document in the 'sbom_type' format.
	Sbom interface{} `json:"sbom"`

	// The type of the SBOM document. Currently only SPDX is supported.
	SbomType ImageSBOMSbomType `json:"sbom_type"`
}

// The purpose of the pipeline. The `buildroot` pipeline was used for
// the build environment dueing the image build. The `image` pipeline
// represents the actual content of the image. Due to the nature of
// some image types, there may be multiple pipelines of the same
// purpose.
type ImageSBOMPipelinePurpose string

// The type of the SBOM document. Currently only SPDX is supported.
type ImageSBOMSbomType string

// ImageStatus defines model for ImageStatus.
type ImageStatus struct {
	Error          *ComposeStatusError `json:"error,omitempty"`
	Status         ImageStatusValue    `json:"status"`
	UploadStatus   *UploadStatus       `json:"upload_status,omitempty"`
	UploadStatuses *[]UploadStatus     `json:"upload_statuses,omitempty"`
}

// ImageStatusValue defines model for ImageStatusValue.
type ImageStatusValue string

// ImageTypes defines model for ImageTypes.
type ImageTypes string

// ImportKeys defines model for ImportKeys.
type ImportKeys struct {
	Files *[]string `json:"files,omitempty"`
}

// Installer defines model for Installer.
type Installer struct {
	SudoNopasswd *[]string `json:"sudo-nopasswd,omitempty"`
	Unattended   *bool     `json:"unattended,omitempty"`
}

// Kernel defines model for Kernel.
type Kernel struct {
	// Appends arguments to the bootloader kernel command line
	Append *string `json:"append,omitempty"`

	// Name of the kernel to use
	Name *string `json:"name,omitempty"`
}

// Koji defines model for Koji.
type Koji struct {
	Name    string `json:"name"`
	Release string `json:"release"`
	Server  string `json:"server"`
	TaskId  int    `json:"task_id"`
	Version string `json:"version"`
}

// KojiLogs defines model for KojiLogs.
type KojiLogs struct {
	Import interface{} `json:"import"`
	Init   interface{} `json:"init"`
}

// KojiStatus defines model for KojiStatus.
type KojiStatus struct {
	BuildId *int `json:"build_id,omitempty"`
}

// List defines model for List.
type List struct {
	Kind  string `json:"kind"`
	Page  int    `json:"page"`
	Size  int    `json:"size"`
	Total int    `json:"total"`
}

// LocalUploadOptions defines model for LocalUploadOptions.
type LocalUploadOptions map[string]interface{}

// LocalUploadStatus defines model for LocalUploadStatus.
type LocalUploadStatus struct {
	ArtifactPath string `json:"artifact_path"`
}

// Locale configuration
type Locale struct {
	// Sets the keyboard layout
	Keyboard *string `json:"keyboard,omitempty"`

	// List of locales to be installed, the first one becomes primary, subsequent ones are secondary
	Languages *[]string `json:"languages,omitempty"`
}

// OCIUploadOptions defines model for OCIUploadOptions.
type OCIUploadOptions map[string]interface{}

// OCIUploadStatus defines model for OCIUploadStatus.
type OCIUploadStatus struct {
	Url string `json:"url"`
}

// OSTree defines model for OSTree.
type OSTree struct {
	// A URL which, if set, is used for fetching content. Implies that `url` is set as well,
	// which will be used for metadata only.
	Contenturl *string `json:"contenturl,omitempty"`

	// Can be either a commit (example: 02604b2da6e954bd34b8b82a835e5a77d2b60ffa), or a branch-like reference (example: rhel/8/x86_64/edge)
	Parent *string `json:"parent,omitempty"`
	Ref    *string `json:"ref,omitempty"`

	// Determines whether a valid subscription manager (candlepin) identity is required to
	// access this repository. Consumer certificates will be used as client certificates when
	// fetching metadata and content.
	Rhsm *bool   `json:"rhsm,omitempty"`
	Url  *string `json:"url,omitempty"`
}

// ObjectReference defines model for ObjectReference.
type ObjectReference struct {
	Href string `json:"href"`
	Id   string `json:"id"`
	Kind string `json:"kind"`
}

// OpenSCAP defines model for OpenSCAP.
type OpenSCAP struct {
	JsonTailoring *OpenSCAPJSONTailoring `json:"json_tailoring,omitempty"`

	// Puts a specified policy ID in the RHSM facts, so that any instances registered to
	// insights will be automatically connected to the compliance policy in the console.
	PolicyId  *string            `json:"policy_id,omitempty"`
	ProfileId string             `json:"profile_id"`
	Tailoring *OpenSCAPTailoring `json:"tailoring,omitempty"`
}

// OpenSCAPJSONTailoring defines model for OpenSCAPJSONTailoring.
type OpenSCAPJSONTailoring struct {
	Filepath  string `json:"filepath"`
	ProfileId string `json:"profile_id"`
}

// OpenSCAPTailoring defines model for OpenSCAPTailoring.
type OpenSCAPTailoring struct {
	Selected   *[]string `json:"selected,omitempty"`
	Unselected *[]string `json:"unselected,omitempty"`
}

// Package defines model for Package.
type Package struct {
	// Name of the package to install. File globbing is supported,
	// eg. 'openssh-*'
	Name string `json:"name"`

	// Optional version of the package to install. If left blank the
	// latest available version will be used. Wildcards are supported
	// eg. '4.11.*'
	Version *string `json:"version,omitempty"`
}

// PackageDetails defines model for PackageDetails.
type PackageDetails struct {
	Arch        string  `json:"arch"`
	Buildtime   *string `json:"buildtime,omitempty"`
	Description *string `json:"description,omitempty"`
	Epoch       *string `json:"epoch,omitempty"`
	License     *string `json:"license,omitempty"`
	Name        string  `json:"name"`
	Release     string  `json:"release"`
	Summary     *string `json:"summary,omitempty"`
	Url         *string `json:"url,omitempty"`
	Version     string  `json:"version"`
}

// PackageGroup defines model for PackageGroup.
type PackageGroup struct {
	// Package group name
	Name string `json:"name"`
}

// PackageMetadata defines model for PackageMetadata.
type PackageMetadata struct {
	Arch string `json:"arch"`

	// Optional package checksum using ALGO:HASH form
	Checksum  *string `json:"checksum,omitempty"`
	Epoch     *string `json:"epoch,omitempty"`
	Name      string  `json:"name"`
	Release   string  `json:"release"`
	Sigmd5    *string `json:"sigmd5,omitempty"`
	Signature *string `json:"signature,omitempty"`
	Type      string  `json:"type"`
	Version   string  `json:"version"`
}

// PulpOSTreeUploadOptions defines model for PulpOSTreeUploadOptions.
type PulpOSTreeUploadOptions struct {
	// Basepath for distributing the repository
	Basepath string `json:"basepath"`

	// Repository to import the ostree commit to
	Repository    *string `json:"repository,omitempty"`
	ServerAddress *string `json:"server_address,omitempty"`
}

// PulpOSTreeUploadStatus defines model for PulpOSTreeUploadStatus.
type PulpOSTreeUploadStatus struct {
	RepoUrl string `json:"repo_url"`
}

// RHSMConfig defines model for RHSMConfig.
type RHSMConfig struct {
	DnfPlugins          *SubManDNFPluginsConfig `json:"dnf_plugins,omitempty"`
	SubscriptionManager *SubManConfig           `json:"subscription_manager,omitempty"`
}

// RHSMCustomization defines model for RHSMCustomization.
type RHSMCustomization struct {
	Config *RHSMConfig `json:"config,omitempty"`
}

// RPMCustomization defines model for RPMCustomization.
type RPMCustomization struct {
	ImportKeys *ImportKeys `json:"import_keys,omitempty"`
}

// Repository configuration.
// At least one of the 'baseurl', 'mirrorlist', 'metalink' properties must
// be specified. If more of them are specified, the order of precedence is
// the same as listed above.
type Repository struct {
	Baseurl  *string `json:"baseurl,omitempty"`
	CheckGpg *bool   `json:"check_gpg,omitempty"`

	// Enables gpg verification of the repository metadata
	CheckRepoGpg *bool `json:"check_repo_gpg,omitempty"`

	// GPG key used to sign packages in this repository.
	Gpgkey     *string `json:"gpgkey,omitempty"`
	IgnoreSsl  *bool   `json:"ignore_ssl,omitempty"`
	Metalink   *string `json:"metalink,omitempty"`
	Mirrorlist *string `json:"mirrorlist,omitempty"`

	// Disables modularity filtering for this repository.
	ModuleHotfixes *bool `json:"module_hotfixes,omitempty"`

	// Naming package sets for a repository assigns it to a specific part
	// (pipeline) of the build process.
	PackageSets *[]string `json:"package_sets,omitempty"`

	// Determines whether a valid subscription is required to access this repository.
	Rhsm *bool `json:"rhsm,omitempty"`
}

// SSHKey defines model for SSHKey.
type SSHKey struct {
	// Adds the key to the user's authorized_keys file
	Key string `json:"key"`

	// User to configure the ssh key for
	User string `json:"user"`
}

// SearchPackagesRequest defines model for SearchPackagesRequest.
type SearchPackagesRequest struct {
	Architecture string `json:"architecture"`
	Distribution string `json:"distribution"`

	// Array of package names to search for. Supports * wildcards for
	// names, but not for versions.
	Packages     []string      `json:"packages"`
	Repositories *[]Repository `json:"repositories,omitempty"`
}

// SearchPackagesResponse defines model for SearchPackagesResponse.
type SearchPackagesResponse struct {
	// Detailed package information from DNF
	Packages []PackageDetails `json:"packages"`
}

// Services defines model for Services.
type Services struct {
	// List of services to disable by default
	Disabled *[]string `json:"disabled,omitempty"`

	// List of services to enable by default
	Enabled *[]string `json:"enabled,omitempty"`

	// List of services to mask by default
	Masked *[]string `json:"masked,omitempty"`
}

// SubManConfig defines model for SubManConfig.
type SubManConfig struct {
	Rhsm      *SubManRHSMConfig      `json:"rhsm,omitempty"`
	Rhsmcertd *SubManRHSMCertdConfig `json:"rhsmcertd,omitempty"`
}

// SubManDNFPluginsConfig defines model for SubManDNFPluginsConfig.
type SubManDNFPluginsConfig struct {
	ProductId           *DNFPluginConfig `json:"product_id,omitempty"`
	SubscriptionManager *DNFPluginConfig `json:"subscription_manager,omitempty"`
}

// SubManRHSMCertdConfig defines model for SubManRHSMCertdConfig.
type SubManRHSMCertdConfig struct {
	AutoRegistration *bool `json:"auto_registration,omitempty"`
}

// SubManRHSMConfig defines model for SubManRHSMConfig.
type SubManRHSMConfig struct {
	ManageRepos *bool `json:"manage_repos,omitempty"`
}

// Subscription defines model for Subscription.
type Subscription struct {
	ActivationKey string `json:"activation_key"`
	BaseUrl       string `json:"base_url"`
	Insights      bool   `json:"insights"`
	Organization  string `json:"organization"`

	// Optional flag to use rhc to register the system, which also always enables Insights.
	Rhc       *bool  `json:"rhc,omitempty"`
	ServerUrl string `json:"server_url"`
}

// Timezone configuration
type Timezone struct {
	// List of ntp servers
	Ntpservers *[]string `json:"ntpservers,omitempty"`

	// Name of the timezone, defaults to UTC
	Timezone *string `json:"timezone,omitempty"`
}

// Options for a given upload destination.
// This should really be oneOf but AWSS3UploadOptions is a subset of
// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
// are also valid AWSS3UploadOptionas objects which violates the oneOf
// rules. Therefore, we have to use anyOf here but be aware that it isn't
// possible to mix and match more schemas together.
type UploadOptions interface{}

// UploadStatus defines model for UploadStatus.
type UploadStatus struct {
	Options interface{}       `json:"options"`
	Status  UploadStatusValue `json:"status"`
	Type    UploadTypes       `json:"type"`
}

// UploadStatusValue defines model for UploadStatusValue.
type UploadStatusValue string

// UploadTarget defines model for UploadTarget.
type UploadTarget struct {
	Type UploadTypes `json:"type"`

	// Options for a given upload destination.
	// This should really be oneOf but AWSS3UploadOptions is a subset of
	// AWSEC2UploadOptions. This means that all AWSEC2UploadOptions objects
	// are also valid AWSS3UploadOptionas objects which violates the oneOf
	// rules. Therefore, we have to use anyOf here but be aware that it isn't
	// possible to mix and match more schemas together.
	UploadOptions UploadOptions `json:"upload_options"`
}

// UploadTypes defines model for UploadTypes.
type UploadTypes string

// User defines model for User.
type User struct {
	Groups *[]string `json:"groups,omitempty"`
	Key    *string   `json:"key,omitempty"`
	Name   string    `json:"name"`

	// If the password starts with $6$, $5$, or $2b$ it will be stored as
	// an encrypted password. Otherwise it will be treated as a plain text
	// password.
	Password *string `json:"password,omitempty"`
}

// Page defines model for page.
type Page string

// Size defines model for size.
type Size string

// PostComposeJSONBody defines parameters for PostCompose.
type PostComposeJSONBody ComposeRequest

// PostCloneComposeJSONBody defines parameters for PostCloneCompose.
type PostCloneComposeJSONBody CloneComposeBody

// PostDepsolveBlueprintJSONBody defines parameters for PostDepsolveBlueprint.
type PostDepsolveBlueprintJSONBody DepsolveRequest

// GetErrorListParams defines parameters for GetErrorList.
type GetErrorListParams struct {
	// Page index
	Page *Page `json:"page,omitempty"`

	// Number of items in each page
	Size *Size `json:"size,omitempty"`
}

// PostSearchPackagesJSONBody defines parameters for PostSearchPackages.
type PostSearchPackagesJSONBody SearchPackagesRequest

// PostComposeJSONRequestBody defines body for PostCompose for application/json ContentType.
type PostComposeJSONRequestBody PostComposeJSONBody

// PostCloneComposeJSONRequestBody defines body for PostCloneCompose for application/json ContentType.
type PostCloneComposeJSONRequestBody PostCloneComposeJSONBody

// PostDepsolveBlueprintJSONRequestBody defines body for PostDepsolveBlueprint for application/json ContentType.
type PostDepsolveBlueprintJSONRequestBody PostDepsolveBlueprintJSONBody

// PostSearchPackagesJSONRequestBody defines body for PostSearchPackages for application/json ContentType.
type PostSearchPackagesJSONRequestBody PostSearchPackagesJSONBody

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// The status of a cloned compose
	// (GET /clones/{id})
	GetCloneStatus(ctx echo.Context, id string) error
	// Create compose
	// (POST /compose)
	PostCompose(ctx echo.Context) error
	// The status of a compose
	// (GET /composes/{id})
	GetComposeStatus(ctx echo.Context, id string) error
	// Clone an existing compose
	// (POST /composes/{id}/clone)
	PostCloneCompose(ctx echo.Context, id string) error
	// Get logs for a compose.
	// (GET /composes/{id}/logs)
	GetComposeLogs(ctx echo.Context, id string) error
	// Get the manifests for a compose.
	// (GET /composes/{id}/manifests)
	GetComposeManifests(ctx echo.Context, id string) error
	// Get the metadata for a compose.
	// (GET /composes/{id}/metadata)
	GetComposeMetadata(ctx echo.Context, id string) error
	// Get the SBOMs for a compose.
	// (GET /composes/{id}/sboms)
	GetComposeSBOMs(ctx echo.Context, id string) error
	// Depsolve one or more blueprints
	// (POST /depsolve/blueprint)
	PostDepsolveBlueprint(ctx echo.Context) error
	// Get a list of all possible errors
	// (GET /errors)
	GetErrorList(ctx echo.Context, params GetErrorListParams) error
	// Get error description
	// (GET /errors/{id})
	GetError(ctx echo.Context, id string) error
	// Get the openapi spec in json format
	// (GET /openapi)
	GetOpenapi(ctx echo.Context) error
	// Search for detailed information on a list of package names
	// (POST /search/packages)
	PostSearchPackages(ctx echo.Context) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetCloneStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetCloneStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetCloneStatus(ctx, id)
	return err
}

// PostCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCompose(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCompose(ctx)
	return err
}

// GetComposeStatus converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeStatus(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeStatus(ctx, id)
	return err
}

// PostCloneCompose converts echo context to params.
func (w *ServerInterfaceWrapper) PostCloneCompose(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostCloneCompose(ctx, id)
	return err
}

// GetComposeLogs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeLogs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeLogs(ctx, id)
	return err
}

// GetComposeManifests converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeManifests(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeManifests(ctx, id)
	return err
}

// GetComposeMetadata converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeMetadata(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeMetadata(ctx, id)
	return err
}

// GetComposeSBOMs converts echo context to params.
func (w *ServerInterfaceWrapper) GetComposeSBOMs(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetComposeSBOMs(ctx, id)
	return err
}

// PostDepsolveBlueprint converts echo context to params.
func (w *ServerInterfaceWrapper) PostDepsolveBlueprint(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostDepsolveBlueprint(ctx)
	return err
}

// GetErrorList converts echo context to params.
func (w *ServerInterfaceWrapper) GetErrorList(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Parameter object where we will unmarshal all parameters from the context
	var params GetErrorListParams
	// ------------- Optional query parameter "page" -------------

	err = runtime.BindQueryParameter("form", true, false, "page", ctx.QueryParams(), &params.Page)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter page: %s", err))
	}

	// ------------- Optional query parameter "size" -------------

	err = runtime.BindQueryParameter("form", true, false, "size", ctx.QueryParams(), &params.Size)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter size: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetErrorList(ctx, params)
	return err
}

// GetError converts echo context to params.
func (w *ServerInterfaceWrapper) GetError(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "id" -------------
	var id string

	err = runtime.BindStyledParameterWithLocation("simple", false, "id", runtime.ParamLocationPath, ctx.Param("id"), &id)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter id: %s", err))
	}

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetError(ctx, id)
	return err
}

// GetOpenapi converts echo context to params.
func (w *ServerInterfaceWrapper) GetOpenapi(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetOpenapi(ctx)
	return err
}

// PostSearchPackages converts echo context to params.
func (w *ServerInterfaceWrapper) PostSearchPackages(ctx echo.Context) error {
	var err error

	ctx.Set(BearerScopes, []string{""})

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostSearchPackages(ctx)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/clones/:id", wrapper.GetCloneStatus)
	router.POST(baseURL+"/compose", wrapper.PostCompose)
	router.GET(baseURL+"/composes/:id", wrapper.GetComposeStatus)
	router.POST(baseURL+"/composes/:id/clone", wrapper.PostCloneCompose)
	router.GET(baseURL+"/composes/:id/logs", wrapper.GetComposeLogs)
	router.GET(baseURL+"/composes/:id/manifests", wrapper.GetComposeManifests)
	router.GET(baseURL+"/composes/:id/metadata", wrapper.GetComposeMetadata)
	router.GET(baseURL+"/composes/:id/sboms", wrapper.GetComposeSBOMs)
	router.POST(baseURL+"/depsolve/blueprint", wrapper.PostDepsolveBlueprint)
	router.GET(baseURL+"/errors", wrapper.GetErrorList)
	router.GET(baseURL+"/errors/:id", wrapper.GetError)
	router.GET(baseURL+"/openapi", wrapper.GetOpenapi)
	router.POST(baseURL+"/search/packages", wrapper.PostSearchPackages)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+x9eXPbOLL4V0HpN1WZedF9WLKrpvbJ8iXftmQ79irlhUhIhEUCDABKluflu/8KBylS",
	"oq44mdnZzR+7E4s4Go1Go2/8kbGo51OCiOCZvT8yPmTQQwIx89cQyf/aiFsM+wJTktnLXMMhApjY6DWT",
	"zaBX6PkuSjQfQzdAmb1MKfP1azaDZZ8vAWLTTDZDoCe/qJbZDLcc5EHZRUx9+TsXDJOh6sbxW8rcl4HX",
	"RwzQAcACeRxgAhC0HGAGjEMTDhBBUywuhUe1XQXP1/CjGrr50DlslVsuJagl0cfVRNC2sQQTuteM+ogJ",
	"LAEZQJejbMaP/fRHhqGhWs/CRNkMdyBDzxMsnGdoWTQwG2NWltn7Z6ZUrlRrO/XGbrFUznzOZhQmUscy",
	"P0DG4FStnaEvAWbIlsMYGD5HzWj/BVlC9tPru/NdCu0rhXr+zQuMAM+gIDdBXORKmeyfuexshhPoc4eK",
	"Z73bcZi8aS78ughVOsLSYV2Hxo6AItCnJIEo6OEkRNDDuaLVqBTru5V6vVbbrdnVfhrGtkTx3GLkvNk1",
	"NNCpvIcE/KDvYksf4QEMXBG1Sx7p9gBwJICgQH0GvwoHAdMFqMP7WxZA4FIyzALaHwTcggLZ4O72vEcw",
	"BwyJgBFk50FbcIBefcygHBp4eOgI0EeAU0oQA8KBBAwoA1Q4iIFAra1HBGRDJHi+R3pkBotgAZLTcocy",
	"gZicDcQmA5DYPYKTE2IOJOwceghArqaSf8enA7PZZlvUp9RFkLx/UzfbzmWkGDA3nRXHp5CNUsd/Cxh6",
	"D7k4Ux+x5/HzEBGk8Zkgncy9XH6ScloOpRwpHN9fgLYn76UTOcw9mI2SBTYeDBBDRIABgiJgiANKgAIY",
	"QPm/McQu7LuoR2zkI2JjMpQt5LgLw+mNQyTwJDYUUPflGEZm5xNLeCKWM3eNSRKhAzWFJgxkA9VBUjHw",
	"Aq4INyD4SyDvWtVwiMeIAIY4DZiFwJDRwM8rmpWTSOqjHhbyaAwY9VQXuXOIC0nIDBKbeoASBPqQI1uu",
	"EIK7u/YBwLxHzAqRbRYY55AKsDQW5FIrtlPxBZ6bL+EifUbHWC4yBP9ZgZ8FEwcxvYVqFnneAtdWiw/x",
	"AonsNsRcIKbgO6ETeURdzAWArgtCMPhejzhC+HyvULCpxfMethjldCDyFvUKiOQCXrBcXIBy7wuGd/9j",
	"jNHkd/VTznJxzoUCcfH/4FvI3J/lRM/RJB8UyiXE4U8S9YQKwH1k4QFGdhZgIX+0kR1YiQ1Zgod5pMvz",
	"jgJ5PtI5f7zvaupKkssG6J4HpUsDC5JbM8yxmjHt/g76EQjP2F4Eqn0gQYo3+wZgqqhmN/plKwf75Wqu",
	"Wi1VcrtFq5bbKZUrxR3UKO6ichp0AhFIxAq4JBC60WZQGRIcYGKrvdYnVPOUa8oEdDehxZAOBR6jnI0Z",
	"sgRl08IgIDb0EBHQ5Qtfcw6d5ATNyalzGuQ5JNWsOhrU+ju5klUZ5Ko2LObgTrmcK/aLO8VyZdeu2/W1",
	"V8kMY4t7u0CBay6EZRdOkkNuwnLmgIwNkAbCvhsgn2EitryKILMcLJAl74pFgmnGvkoaCDiKrnpLawN5",
	"0B4AFw0EQJ4vpuqTQyW3YpbTIxPsuoqe+CKFvzZ2nneqaTRsUSIgJkY1m7sJw2+aZrmEC3l9eakQKcw4",
	"SJIqdAFkYgAtKetG4vMvDA0ye5n/V5hpggWj6xSicdPEaivggnr4DUbX/aqhos1oJbt9nbvVU+R5G3PB",
	"6OKqu1JQlN9wP1AMZbvd6BE9MFi1HwNkUwZzld20LVHUz9M0ZGskWYf+LsHqy1ucC+i6yN4U+WYUzXJT",
	"8O9ROzC67hyFEgBdbCRQX4/Cs1J2lXtpq5/70BpNILO5whIUsI9dLKZq9dtAlwZYeKIX8BXCshRj78VV",
	"GjRjxHiqjNIEHHljxIBpAYgyLiS2v56v5+vFtYxoPQtqLRyWLRiSBS3ExPrT2mzJZomp9PnRdwdOw/zB",
	"7KNEvsUQFJHIGTENvA3XCIecpm3HwKbr+h8dXKmWOJW6j+TP3wvUaH/kqKngytmmXCAvRciVAigdgFkb",
	"4EmB0aeYiBiI3wSMmTQVpDSec0ikCgOO2tcd4FEbpaqXA8zQBLruFpCYDiG3W46FGbPbbtVL+Zvk0enq",
	"U4uSAR4qTS5k5qphmhY2JDi8WFZB0Q7bKQuh4j7q/DzbaIytNSpcvAPQHbLACphUOt0poMSdystlELjR",
	"3YTsIcpx7Pmu0hhyIcdjQC5h7hIq2Ghc4DZMXWDYce0Ko4Zfs5kRYgStJYMz3cpoei5a1/5ct/qazVAf",
	"EW5Bf2NCu/IR6bSa1/qaYEJtBibDZ0XLCUsADATNuWNvwR7QQS6yBHCkbK5Fg5GR4cMbPhoZ2XnwIRzo",
	"g/4uRQcGJyAgLuK8R4RSBCBDSmmmDHiUocQJx1KHwZYDLMiR1AOicc7vL/LggxobuhM45T0ScMTl71mA",
	"pB4/cZBiXGYKQgF6FQzGx8+DDwxOPgDVU0IWgc97JG2QJXAmbRYMTjLZjMZfhMrPqWqmTzledm/cxr7K",
	"Qz9hWCh5uICEVZgGXl71z9uFJIc2Vo5LKpBEMRTyGw+RIJQQBqAA/QC7NhDYQ/nNhZKInCLoUu8g5nBv",
	"3VC3J52LhZuU+ev7XS9244hJnrAW/E7YTvbhzghNl7Nbzh0wQlO+KWo6nZMzlIoNieM3Stae7m7Y7ms2",
	"E3DNcNJhk1/fc//d8TSN4+sq+Urd3ykinlZS1BW9TmbQdJaUvGwoYLq6JSEP+b8aHXLgu1COjF7FUm1h",
	"cTB1/82PBMEQ2/IsQ2O4Mffb7E5gVLksKEFXg8zePxel7egXTAQaSoR+1kpDmksPMQ9zKQRzoAeILioF",
	"ESaAWgKq68uDIgFIcaeaqq/6UDhpgr5wQKSSusk1KdbhTc3vCyOmE93VhGiPYBJ/QYg/2es7oW9O6lcr",
	"/LyOKmfSY5K0PEzSfZzy1/h6jGiJCehPBeLxZZRL1Xq1UdmpNrKZ19yQ5gwoASZip6qVxPAaSNpYCmPI",
	"1qo1sc7ZCN41C54JmCsVnHmZXnezgWVEO807F3xK1KhB6XxHfQa/Sq2XMgEYJEPEf1MGZJ9RQS3qKrYk",
	"pZM4Gv+ZKZf3hOVnsplG0fwDe9BX/9zO1bghpw8XHOf4krdqu9gmzDIc4Un12o5ZRsLWAlFKfscFQ9BL",
	"Xe4Lp+RZQOxS9csaEMNpTjtXl92ok2QN1MXWNNUcex0IeXojUzrQbUH7IGTa8mIGkl/zLOCSkUABIJlq",
	"IZxYUlSKnAVA0B6RdDt0BI+kQCn1eFBgC7ruVFIcQcpKb9iSXImL5VDh5GZmixJOXSOPGE64lwkCZRJd",
	"5H+MytNrVrlIOdtiMYbBeT40m2nl4YwJRQsb34ccBcxN0t+MXYSmbMsmeYZsB2oztqUvwoKNuSgwB7mN",
	"QqOgTZgFOSLlBcoLCWwxnGqgnztHSGmzccwltFgXLbUxDf2h5SBrlN516A+V0BRf5VpgluyghwR0MRml",
	"Y8rDjFHG89qA6DMqtyNP2bAQ9vuHFJB/Dw2M5V5QLJZ3ILOc3yMj8Dq06UlczMUiEBEM8nPeQkRQrub/",
	"B0Mughz93sjpox6bGcr/36nqXxR8+5Cjq84msChz5LNDxQC/pluauNxUDlRLyLCYyvtNoJi8oVzsIZUu",
	"c5Ivty8yTOWwsY/R7a31mefV5MG5O0YMD6Zpn+edD2tO252RVraw860zhA/TOKaWH7EdWr8lH0TQDiWI",
	"UG/OpmBkmf26qX2rdABmwMfsO9C2tedaSlaCxsX7GQmq5qVNzrpD02w8XTPBBw5kAxA5wNKGTNWUpIak",
	"g1CkopSQ/jh3csgu12qlXdBsNputyuUbbJXcp4N26bJ7WJO/tS/Z8dkhu3jEHy8u7ibBCbxtnnq357T9",
	"djsofzko2we1t+J+97Ww85oG06JfSy6nlC4qcz6hLM07adznpgHgAjJ1kwkH/LLzSxb8UvslK+XcX8r9",
	"XyILRB8BLqi8/yDvEUgAIhab+vKOC0fKgyvhIDbBMcNFHwGh9CNbi9AzdaZHon7xMxkP30Ja6JsPAxhi",
	"AtRHQ56pcn0aWcvj8y1UvallPtVYvmWEE/KeI8N8TJjM5XL7h8ftS9A6vO22j9qtZvcwl8v1euSi3W4V",
	"D1qtZh8Pm5P2fnPYvmvn8/lej+RyucPLg7ku7wjvmwGXuvpY7OI+tdXpmelCq8SRlNhHpVjGf7lF3KfE",
	"REW67gajXinIbpEK1LGQ0r/mnMV28jCVyhVUre3Uc6ix28+VynYlB6u1nVy1vLNTq1WrxWKxuF5M24Sn",
	"R6ub+bG/fVGr2ie85Xpajc+2/R+ESb2kczrk33VRKhRAGQ1TpTsDQlJNlkyDDaCF/viadjGN6AteayKn",
	"L1itJT02wQC0EhUXkOAB4uK74sOLD/p+ZMwbBqLRV68MCRha0L7XwqiUWdGzRT0Pi9Rwnl8dyJ3fwptC",
	"7oAApnn2G3zSWhbCxHIDFRl4eXh/29zSLx0hYgM9PYa/Wx2+t/ZaIlTooOvZDs0FZ2Qz/SgY5vPX+Yus",
	"Hw+U2chCu338R0rYRyx0I8mRpCaZa2SWBlWyGV5Werxk4xCH8503t7TMD/OtbGLhFCUQENv2zv7Vxfdl",
	"juEyF0VsORewqRV4yqAttTCVUKH9ZvrwROYPHU4Tp/2NBpwFrxrnz+FshoAHygrjKElVAKmZCiAmVA3E",
	"s8qnFQ6ifUKIjDGjRI6vTHuxFj0CLRFAFxjDROSgVfNuemjVhsvpU70lq/iiHn4lT/weQkTa1cejcdcv",
	"zUgY2URXtOWJmI2SdiA2hEeei9lAm/VJIPJeZffM74MZKLnATfblkDHKUsyiSECsjGPz5qCEfQHyVMV9",
	"UTSKGi8AoNcjuaFx1/LAshCXaxlA7AZMalAmSF0uKKbTRg0XuOYsjG9hZSvi0xei6cIYwyiaeWlguI4O",
	"TXMaGzKe2VrDQcOIxaSXRlly2TRvflJGRzXrnoDDVOOCy59nJpxFtx2jLuied4BqgwfYCh0N0aQq82Od",
	"8ccsMFW1Cpf0nmyIFdsS7YdR1a1k7Odc6AjlimmmogoOU1g4HG45g46XT1UI1uEmxgu3MJLhobn7582L",
	"8veQ44cS6kKWxWwxJsUjpLF0w4ZJiplzV90cXKanb8zh5ksAp3lMC97U5BIUzH7srcDafLpNNlxyKrUp",
	"sWoDy/6/iWFfGV+fh/4w3QCrP4eW2vQ27/INGEvhT+P/Dzf+fze7Pefu83ut8n9l+G0ycP97xd0/rw7P",
	"OlTBZPE2iWjwmIMVE5DU5PKg6yCOeiTROx4kLy9rG/mcumNk0rMEw2iMovHzoBnh151mVTAdn32emanh",
	"2GR4Yc+nLOaF/ddCHNm/Zj6AHjHMe8Z0N8PrPLdMQe9ctPRfEvG8YQTAJiHLGw+1PuB45Qjt6842EcZh",
	"+MLCaVnmk/q3CjOO5yr9jD7+20YfJ4OOZ3bAmC/Hp1wMGeLbhQH9jGD+t4hg9uFUCud/yVWpjt3G92WP",
	"hEfzqgOw4MgdqEIIUz0YoSofPMpUn7OIMUoFoKxHIJmacgMS0XETuIqAsxDnvymYw4mfORIcDDBy7XDM",
	"heVgDvCQUBYmx23Ebv8DArBjWa9r+8XbviOkevPLf/MQ6YPLo2s3GGKir7NFBXGFPpU6niHkTZ0Tq3Nr",
	"N8l8/Tb3xLe4F+YZxbtJfU47ma1kDr5sEjGfE3ieOdPn4g/+ctdVMhraQJOmf80E5OUx+pF0/y2B+ojw",
	"gKFnH7KwlNXqqjOHqj0IE1CA7ghiwj9ArzhuoYlHEW4QyT9bjQ7nj6L4TVQ/tv+ScP4ZWCtj+uu12rfF",
	"9MfDtBYC+23MvjGufw6bUUy/CfH/HsjcNLg/chF8L/+NZfZwMe897nWQPWCsukYK79rM/WDp5FDTfG7g",
	"dBeJWvK5MTRttmzVeoUnciMWpFH9HqebVKy3TEVoH1wZLQpQ0qeQrUtKsPGzNxg+a3Q/SyCePWg9S1a1",
	"ZF9xQJ79oP88QtNnB3JnfStMOLLMlbm6paT9WVTaoqEOkkDy0EABK+UixJ6XVn5aIH6l5m+H0I5OX4kS",
	"kwFHQtWQWSqFrOPcOopYldqaGzuT3UiE+Rski/3A+2yNp+tnotp/T6Lamvy0579bgtrz0gy1dHvjzyy1",
	"LbPUvq5AbSc26jdhNQRLxQLochaUAVunjaRcuzx2Y6SmSMfGm40Sw6dALkFiO9wl7ql1s+rGyUkHQm4c",
	"Ef6Wwd1L8f4U5g1ugfR9TGwAozQPgsSEshHQYQ06yQO8UaKuQYYkVJYAgsHBAFsq/qNHhEM5inpENQXV",
	"tYyEwGQYXXlypLQLM93sTmK2bdkzC/BC/aZwWmUdg77vTlWqX7x06GzSJeEpK45oOHx4tygbzdKwt15Q",
	"LFYs3Uf9G/2zoH/zIB/pXz7/n/7lotnSP/wf9jkSe/pX9W/9+3onehotHLeu3xNu0g+sERLL3QyQaOlB",
	"3redbvPyoHl7ADqCMjhEwHIh52BfDZGfrx1p/siZGbask9l1kFbz5mKRImehZJqqHK8NWtTzA4HAIRli",
	"Eob89Ug3KuSnBporrTnBwjHy3XHrGhhPfdYYxTFX5tukcVaHLepqrjPHpSoyligCGdXc7JEPJnSS5aCP",
	"c3rLgwDbesc/hJKMmU6KBSIB9TY1OWcVZBdRKZeov8eqHEZrCl0McU9sDL/y1Bt8qqq8ESqh/BvbavSw",
	"JGYedBACUXCJSwM7P6R0aEK4uCYdVRmxEFXWNMVMk5U0VTBP4AqcM5BHVTctl3LERSikmfNHfjUFL0Py",
	"1IQZdftNotmSvIskE4HnkYyCLepUp7MRgxe1bhA2l/CqUZKUnEa+ijzzPaLiZQ2RKKybkIJYonQkWJpp",
	"lCMvD+4VBFoY5gAytNcjAOTAByls7v2BPIhdbH/9sAeaBKi/ALRthjjXqgRDPkNcqS/RXJYcAswtKw+O",
	"KAMGe1nwAbrYQv8bC9v7kDczm/uxqfttCYOe2gyxbG5vmlNOkBz0/f+Fvs99KvJD0ynsEwdJaS7bYsOs",
	"P6zfKuGaQ4HtYcJTcWBTD2Ky94f+r5xQHU/QCbBAQP8KfvUZ9iCb/rY4uevqCcMsTHPTQmH6zmNkdvQ+",
	"SJHqwxxM6aduNWmGNW81c1AJiZBMeyTEb29OdlUEt0AVmUgYDelh083LGD11bxHNmWzGIDj+4w+plB/d",
	"u9+vxqm6m+X4z/OJWpBbiNiQiFyfQWznKsVKrVRZqyTFhsuuK5l6HKr+WwgPq7OSDVvSxoGZUeVX6uvh",
	"f0vNTF5fNntuwG8v0diOxWhsIUGH3dbogiqm2db6wiYRIIdhex1Lw0WfUrFp56OoQ6qQuDDHlmFwkf9w",
	"nYFZtVuF66P4yrYAITUa95rRMeY62ALc3Z5vFFSbCl080efHuzX1UdQ/b5Bv0Z362jGtM+DWxrZ0urLV",
	"j3Bqxh9nMTbJ4oLV19iI1CKzkW0oDx4cRMJHForxMtuyA5YXq4cJ9gKvR2w0UPVq+9NYOyXXJC+Xanm3",
	"urtTL+/uLDMyaXH9mfobpaolNalZd/N2Q7psLefU6Ui6n9JVlODqu2j+9QeTASWQB/QieY9AwJEPmWSO",
	"prWNpMalhV11wWLBAZ2QcIo8uDDj98jskQMzh9QiJkhqx3wGRvjN8FD1UsVImQIY6hEe+PrG3yLOQ+Oq",
	"q8Zde5EmTkniAMxR6efwNKosrEXHN/aRi8lardEs08Tcg7Cb0e4co2dFgT56lL5U+IxOqJLZomLE+dTL",
	"OoTFD1j4EtAiOOZj9ByC6aRjcf6lwGOUin/FYIRGGxxQpg0bi9lvdoAkz5sdDtXEDKp+mQ2ognpCAVIr",
	"Cssz5cBBEKXoEPVmBqCDHuHUix9DnjWRWx5UoU4RmYVzJgitRwwS8rFQrmjlITmkxnHxPvU2yDYMPTUf",
	"ZHtFVx+M6hPbuU1yn6P+K466WVkCgDxoJcMuO9cHnyRTm52s2Nq5b7+mLHc+06ivpeQIpOwc+aeQ4Oz4",
	"LJFKUejD3jjPLnLFbp1naDL0Ii662QDJWghznbe4x+bHWcmfwjzBJPq2SsnLapLW/9RA63+HRclM3t4C",
	"jcfu+NhUcCKngROec2COOQE2f8X+yaEf/fmmgdGPmSDo1xNfkn/E+qlw4ChF3vwVZiCYH2aRvtnMUPke",
	"hlY0wFCKTJFCo/6b6ICpyElxD/bd5NDyQzSx/iP5cX4UBiezeahIDWLOZDMuHichUEIFdHM6dpRaEuox",
	"9yX7mv0rR8cwk81MuLtki+QhPjP1w5InajF0/xusuO14NHVyfB7YNEeoKsNjb5fBFBAoBCL25iF+Z1F8",
	"9jYisC/PQIpbXf3OAWRDkxNuLhZJECp3jgEdEK6qNEgRSjKzhC2OUO6J3weUWWhVqaXl2qKZIKpBNBta",
	"f8nZqB8MN0tiPDP5/t+Qzjmb9khnfrVcGti5fciX2HJVrlayZ7lYLhZ3i/V8MdU+qSI60rPSRvQFp6Sk",
	"yZ+doL9JMh/ko3mrRLWcpr/HHl2YwVFZ/4KZAX82ldnc2YgzrHxesjdhaZl5Q4w8vCaDm6jSIQuBRESz",
	"Id1y2fDL7lTF9zfBThpNhcFVySGlaL7kIY0hWpIsZzSzxS+CCuimfZrDgpo0Gz3RqV/G1J2zS2OtsurF",
	"L3c7H9SqMZa+l2jib57DqI01zxwmmi+FG21p/NGd1ph+RmiqwscWOVMHGRk8bAJcOKVBMlwlSE3ldyEZ",
	"BulBv6HXQWfLLDylkjXxGky2Igj0kUU9xIGxMmfV21zoS6CUASm7Q4YARxYlNjTZ0TFzLiLPd538Xfco",
	"13ivH/uq1X4n3UQj/JCnDY0lZW8xblNpTqk2qaZ6MFLpmcp9zZHIRv69AWVggITlSOXNjJIHbSnIIONp",
	"+FfA3H8pzQGJUJPP9ohWXBOpmMrMYGK0ldKxxOetA8JSwtMgkWMhrNJGoKmUBH41e70HiuWdYrVftuEO",
	"2q1V+3al2m/0G2XYqNRQDdbrdrm/UxwM4G9ZHcbUZ5BYTs7FIwRYVO9hNh5zkDtLJpey5W9znrfFFumX",
	"42AxrH+Dbib1ZHU43QESiHlKhZ04yKBGu/MST9h5kMAhYuBXCxLbRT4mvwFsIyKwmOr3QjV9qegEqNSG",
	"hSqnoEUJDzzEgCWJS9WkmE+4hRxYLpZHM9nGQaRHIlqK6EAKUSFhLSmiunnM53wE88JBcMxWLFo402+v",
	"JddaWpkUcxmpGVLP5tJK1j9LVf8NS1Wnb0OqsrXk/l+zmOXgZGejroJsBVRcJW+irbWzb+mXdk7DN9C+",
	"W6WZ0FhpkokEDYWJPDjCLgJDl/b7JnAlsnBlewQN8+CDysHlTu5/Psxxd+EFqfVyl77TdmU8hdE7bSvg",
	"Cl/667uQjHRFMF1pJZY7GQ6TePYPPGDXttSDeEruCZdjVlPNl0r5haVU8hX47Y5Hs18HUZZHik8plRSU",
	"piGwtyxrZHURaeTTJeO62EIm0Wypir1KR015FNaTomXqt/T7J0EGG+A1TS/UuXSrUP4tXu70c5J46XEx",
	"eBsSqOTnnKDU5e8mlXg9zQ1pRRXU4YG34liF5yhsCgIuD3Xz/Phq76TZOVE29GT5bAeWazt7tXKt3mjY",
	"qGLb1Wp1t26V63a1VC/XdhqVnZ1+uVhpFOFOf6derA+KsLRbL1brFVS15T92YHWQmvewlDq/jQLx0LNr",
	"yz5p18YKdvse+jTG+rVkKrc3cH2tZbwriBNylJ7LsG++KGVhlndqXEczUXRlSux0xRtgKmVT202Mx00w",
	"hEJdQpWIX2KpejYBVupaX2l+mk+lDVebel7mELpML1SFpjZSDqOWadOpVPUl2dU2GTz7Kv+ab5BFfgFJ",
	"lK/NzZDzr2sbnWOz0cIxvi4Dez4fYlnMx9pU/VUTXa+bR9POc/g2x2rXUmSFT59sM4JN2G7yPdIMa4+q",
	"EhRawvhgaqd9yIIPs3Ja6i9TxusDmK1DhWb2SB/NVAIlkKhiFnpETwsXyTg7ymwdvukzZCFbqctYV+/Q",
	"HnrIVaC+VAP7dJwaSR8r8vbn1XbbupbbZol9Q39oyjOaQN/oKfto80JFd4luO6vzNheUdn0MRmga1eSQ",
	"V8DM/a9Up6Rqnrj1crmosP/18TW4vts/b7fA2eEj2D+/ap2pzz3SI95N+3L/uGl1LLp/2Dw4HzQeT0bo",
	"7XQH2u7F46QOj4/b7il0ReP0pfxa2C+ffXTag3bweiz8+5c66pHz2+HBXX3nBXZr/v1BzTu6OK34I0TQ",
	"bcHqel++3Iwupzfc+VSmN58mh293nX6pdXnRGrSOh6NPjZtyj7w9jVjbarGj4k15ws76Lgxs5+4jvoek",
	"ecC9UuPx8Avv15p3lbot7thF5ebRfhju3n78hK8H943bHjnbf+kWK+P7/Sv7osMfK7vnsEV22n7pauw3",
	"2oe00EaH94+lL17r6roJz4r905NKMBhWWwEa8Y/dTo9Mbh66qHX+Gjyd71xdfKJX12eT8cXN4LU/LH06",
	"aIyDp+KZeClYlyflVxgUXz3eDHZPTn00Gl9d3766PTL9Il6mTwNG7zE6mvqTp+H4ZiIIuWgUhp3DoHB6",
	"32WPxVrZO7zr1ltWv14dWSdH3aPBxcglo+NCjxQHd9XmLawVqyeV15fiSPRRZXxmXX+i11fB2f49P+mM",
	"i8W748fm9BoF04+NunVXeDx0LuqjSuf+7KVHdlD7aTjFF1fFiVt6PD64PbMCdzLiu82PgTsalmi3X+WV",
	"N+9pfF2sH9Pu60O1/ALPag+dj5fOE0I90tgpfqL3Tt8qnfmdjy+DJ/rC2aF4alz3754+Po6PGrc+sx+a",
	"7OWkfzoqn/q3Z83XrvPKb5p83zku9UjxPHgtP8CL/eKw3K5dWxf2acH68kKLDctiL/ufAvz6wHANB7sX",
	"n/zGl25h0Hm79LjdHpJG4cvTWY/gxk3gDoJ6PfjiPBQmotwXBIvhLf/y4rxeBC+Pd9WnftUZiaOGc3ZX",
	"+PSpXi1/cc5rZ5PmbfOmud8j4uDo+Onhdmx5h8Ozg4vSWafZePLuR/3KqXPevSidf9qfwoeSYxG3Gf5u",
	"nZyOoXf/Yrdq4x6xPOsjvjm92t+/2G81m9UjfHiITnY85hyd1IN7fnN+cVEuPtasJ4e8PjaOmp46Q63j",
	"SeOoNRm1e2R/0j4+uqGnrSZv7e8/tpqTw9bJ8LB1VG02W8PRzaz3x8vHZqG+/+gP3Wmn+fR44rxMz5we",
	"KXwc7LxdD+7H/ZNy8fBLZdSuXx3tXxbJ+aeP+3clLxh3Pn7pBp3Kwznbr3iV48AV/tnt4enZufBqhwc9",
	"UmLHb5+atFua+ruP7cZ588C+aLWupi/NF04f7hr1x7ug9bHQJy+si27L57dXrcH0ulXfedht1PDVfY94",
	"tc7HPr85mNRb5XPm2s2L6sVBQKdPpQ4Wx/CpenZzfi8+dg9hqYr5Y+e49fJG69ePjfvK6dWoVuyR4ZeH",
	"YaN8Weh75cO3Tr3bqDwcHvRL7vil2nbHr8P2lzM0LJXePj2+euyx83R62hqM3wYf3cvOTvA6POmRl9fC",
	"aXHqPpXPcf+Y7Rw3m9Or3bsH1nzqTDoXxUPrpduYHLbI66hzEEy/eA+T+/Hl/qfgsH3fuEKVxx65wHel",
	"wellg9v1A58fvdYuPn6yyQW56Xw8YS/d67ODivfA3KZNDruO/XjfeHka+Q/OwZRXCru76KpHnFGRnZNp",
	"8eVyMoLBoIDvGlfWzqfxxejl/PbidFi7270/m54GDw/ibfKJvFxc1h5uj/a/nFX5E/UuLnpkIPrdk9LH",
	"2rR/+1BoVsb7ffh6+1AW9bu3yxfrDY06T4cYnl/unhdOrNNW+7Z0c9TYaZQP7KZ7eLRr98ioPLzBj52b",
	"JoSnxdPT5tvJ+HZ0e3p+PjwrP9484pPL+2lZVE6nRwPOoFebdFoPVwPnGrWn5/vdp9MeGTP/0r3uowHv",
	"7tbq3UF5/7IdDN+eWKt2/3rQORs9DW+d0v3xuNO+Ia3p2+hmunN4V/5y7eOH2q7kUc51+9MTO6PWWeXs",
	"vLNbwG+nN91bV7xcNH/vkd+vB926eh5GPxCz4upZUoGOMvTMuZt+Sf+sY7r+EbOVjoLv9ahZvCBXqj1O",
	"jheq6rpql3K3xKQiyKVAw4FSuWL5OqoYWI/8GsaJ/ZZaGGwhYyMsHE23LH73fT0sSScKWOJD2bDwg3kE",
	"eTu9OlWUbNp25MINrfHmuTIYCIcy/IZspc8sVg/Y6PWxZucBi9HVSfWuUa8e2nz/jkxFv9KfjG+HwxP3",
	"xu0/fnLrpFQc7y6pXJ1ahOBOv9kWqT86C808Ji1JKmm/sj1M1sfTcxWyIfGUph13kDyPxoTF/7z4+m8p",
	"ALa8pFZTkrfS0swZJNDTTnau1idxlwcdbTfm4H/AJDIoqwhe1TwL+oFQeVPy8BqbEJ8Lt15/wH5wlbII",
	"CeuLlM3v7falyrT5W71Mp/GKiWbS8vCrlwYOLo+2rFkWmtTfVbJs43IG36EsAehPY0/apZRpD8vq2ukX",
	"KGnrLqXvUq9gLTRkoCI5+dbAeJCPNoVFtl0Lia7gsC1WUq+GuLls0VC4QcFKPULcFqbvQgsxYW/RWTZf",
	"ZU1bYiZcPHOM2kGURriyfPVcichvtDguDLMc+vmFLjo0AkGfzdMMcM6XtfqKn9+FvZSn0fQ7UD7lW4ya",
	"8KrNAWsJPNY11IywkEj05MhiSOT0I6SRBBo9+plW8RJy9Jxqz1s0520g1YZhBYnhllV/omwIScxQG488",
	"rRYr5Wp6VI21XuSLPE4DFw7Dkg7MsXSRER0IESvrFVZhgC6npgaxYVActM2K5oTWZWtK1jmLv5kz29a8",
	"PKsxxK7F69xlksBbdp4mEjDENji2OWmXUDdWSHaL+MSw25oIRSJ8DdWKaEIifBA2SqgHxTyhTDg56CGG",
	"LZj3KXXzRPhSPctkM6VVn7fSJ+LFdJdHKYStsuGFoS6Ru24rIdDedQqHUNIZ2SzWe9EfR6YbP5I6n0e4",
	"tk+nsl2Xhaova+d4CxjarsuS54zWdUsJB17XZSEOdF2HZW7Tr5/TOU+oMuu36BaTLFV1E8wBd2jg2oAh",
	"FXTVV1XJrwZKdF/cJJ2zqmJnhUqSS9n7PFDjeggSE98JXRekNASa8niPQIY049Mq8cK8MGpruOQYUxXp",
	"ol1KEuAeYYGLdI1yhgaUoSyYIODAcVRPR1EzUDl8cnV9BOAEhmUEsQCYkw+iR3zKOe7roogeflXhhR4U",
	"lqN9W2Y/gKBDpchLphydnWWu11gu7jYPD8/lc218pDbsMV/PYYsDtWGP9CewNj4bG7Zf4gDf4tTGnyHe",
	"PmUvSvrbJL3d5BDr/PZlL/mZcIqQbD7PEdiWSXosIGRZJl4ipXmBbrde0Duzz9OjSuaG/Lz06lqeUZjn",
	"lSiVL0wcjGffUQvnDYvRlZQkAgPXz5v6A+ZZjnQUGtvTNlVEondfUtQ89bG0yftiC/L3z6f+3/fU/wb6",
	"ymZRbEoMtwKGxbQjSV1v+z6CTNNKX/3rKJzu9KErhWbVUgrzul00qtSFMl+/KuVmQNNSbHSJKEGNlVuV",
	"atNhojqFnecziZBHvYmZpg8tB4GySq9TCkPkDZlMJnmoPisXhOnLC+ft1uFl5zBXzhfzjvBcLbQKRQhX",
	"nX01vUmmZkDVQgPQx7GgsL1MOXy2Rn7Yy1TyxXwpo0vTKjQVLJcSxAt/YPurOi1p1fqOkY6+0jxT1e0D",
	"htFJulHB4kiETxVq4xqMnvU1wo9+LSBmladMGSxnRQZUwR1MCVAsFtk6qz0qI962NSjxJ/NV+gn0kFCq",
	"xj9THu0OS4WEwAsKhqpeICaK9oQTxtLthQ+ohhSnlT7NPn/Iy/af5Wzasqk2o1wsxvJ/TO6ra6JVCi+m",
	"CvsMoJXiQAxLipyTmInjRJJI9TtObVL6FydtEy10GsoA2NZTl3781M1AVV0eIeX4wRoQPXvlx89+R2a+",
	"G0mBPmKSNkBE2xqS6p8ByYjQCZnbgtqfsft3BL36OstElYkA1FKPidkJFq5Occi8//lZnpEo2lsVyYgz",
	"IcW8InpS4xTCP1S95LT3XFu6UBgEBE3CrlngU7l0HKbDcFOUVNmOx4jBkLkrfm9UPPWgufbRYRZX+Pgi",
	"47qmXBhebZgM4mKf2tPvd+KTb/t/TV6fkpl9XeA3pe89e9tO23rzUVXGUeIHsv8ypsNmD+7/5Dw/Oc+G",
	"nMcwjTRO872Epy3kpRCHawSleJ2dzUSlaOD/MmEpgakUCkri5afA9JNt/U0FpqX8SyuCcakpRX6RTWZC",
	"zAb8JMas/o24yA+QvWKYUQP/2dJXbP4oWCaFpFQFQzSZlVruq0J/utTtEplMoFdRUHacJDzzqN2Ye1W/",
	"1wRpZ/Nr4taWaEk8MrDiALimvM+33OIDTDB3Ypc4WHmHYzG7urNKo1AuGQ8JmAhTgn0aCJOjwgNXrLrm",
	"VXWin5f82kte4WnJ0ZAkEL0Fob15kYKICSBUvzNsBS5kpgIk+FU4NBg6xp922rm6/C3/H3eQjtVDB8PQ",
	"0RlSedox8iDBA8TF+rMUtdzgON0iETDCVRJd2E8Bo3Rww86IOSqKv5tauFFji6qDFVWJM9sX1gKGAsTN",
	"saa0qw5Jh6Rg/s6Fw+VrK47iRYSCn+dx7XmcIWvJoUxs98LB/M88a8njscGhiyXwrz5zUUUneeQWzpl+",
	"hgW9QkskLiKmjh+ygY100UWaOGuR6V8V0V51MkI4fx6M9QcjeiB5ybkIt3Kbc/FTSf2ppP67KakLvGk9",
	"v+N96i0XMEJhAQIdO5Usps3XyA09MtccsqiNqrs9K/291OS2f3Wx5eUvYdIBV5rNgXCM/xLTm1rtEk6n",
	"Pv63Xf+zRc8fBds84F+Yvfq/0mwTPvi/HzX/MUaQcJ6tPFDFHzD9cvtH2GaWFeTi0Bf0J16V4Q7+dEYt",
	"Xph/l1srJCVd14XpiNXoROoAu4IaPH5RLdwYsyfwF66LtJXNmhRUIeVlgZexdqrS8g/l4bM1pJFc9Bis",
	"QcZPWv9rhENN6H8/0XD2mjB0XRCFjIfUNDtm6/2wkEQlUkPvhIZsVmu1PwVKBko/qJt7PZBp/i7xrfIn",
	"C2NLt1J9APHffp7in6d4m1OMFilIntwoNHX5DXllmryT7uejhhcWakBRvEDqe3IIo+v9HbXplcuRqNfl",
	"BQrxDPrlOkQyH/8HKRDpBR3+ZDViSeWBlM3SLUEIiY6oD/UKe1Yq4E9VLXgI1E/F4m+qWHSish+GiJCd",
	"sMVTEhOJEkVDNEBR5u2CdHJhXn9W6fvqyfLoWZxkQgL0cV7V2XbwQCeDQx8X9PNbyg+GWC58er4wList",
	"ZO5sCDjEZLhqAi7gEL1zGks/i2dep46mWTfO56//PwAA//8Rn1pBoNoAAA==",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
